---
title: in operator
slug: Web/JavaScript/Reference/Operators/in
tags:
  - JavaScript
  - Language feature
  - Operator
  - Relational Operators
---
<div>{{jsSidebar("Operators")}}</div>

<p><span class="seoSummary">The <strong><code>in</code> operator</strong> returns <code>true</code> if the specified property is in the specified object or its prototype chain.</span></p>

<div>{{EmbedInteractiveExample("pages/js/expressions-inoperator.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>prop</var> in <var>object</var></pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>prop</var></code></dt>
 <dd>A string or symbol representing a property name or array index (non-symbols will be coerced to strings).</dd>
</dl>

<dl>
 <dt><code><var>object</var></code></dt>
 <dd>Object to check if it (or its prototype chain) <span class="short_text" id="result_box" lang="en">contains</span> the property with specified name (<code><var>prop</var></code>).</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Basic_usage">Basic usage</h3>

<p>The following examples show some uses of the <code>in</code> operator.</p>

<pre class="brush:js notranslate">// Arrays
let trees = ['redwood', 'bay', 'cedar', 'oak', 'maple']
0 in trees        // returns true
3 in trees        // returns true
6 in trees        // returns false
'bay' in trees    // returns false (you must specify the index number, not the value at that index)
'length' in trees // returns true (length is an Array property)
Symbol.iterator in trees // returns true (arrays are iterable, works only in ES2015+)

// Predefined objects
'PI' in Math          // returns true

// Custom objects
let mycar = {make: 'Honda', model: 'Accord', year: 1998}
'make' in mycar  // returns true
'model' in mycar // returns true
</pre>

<p>You must specify an object on the right side of the <code>in</code> operator. For example, you can specify a string created with the <code>String</code> constructor, but you cannot specify a string literal.</p>

<pre class="brush:js notranslate">let color1 = new String('green')
'length' in color1 // returns true

let color2 = 'coral'
// generates an error (color2 is not a String object)
'length' in color2
</pre>

<h3 id="Using_in_with_deleted_or_undefined_properties">Using <code>in</code> with deleted or undefined properties</h3>

<p>If you delete a property with the <code><a href="/en-US/docs/Web/JavaScript/Reference/Operators/delete">delete</a></code> operator, the <code>in</code> operator returns <code>false</code> for that property.</p>

<pre class="brush:js notranslate">let mycar = {make: 'Honda', model: 'Accord', year: 1998}
delete mycar.make
'make' in mycar   // returns false

let trees = new Array('redwood', 'bay', 'cedar', 'oak', 'maple')
delete trees[3]
3 in trees  // returns false
</pre>

<p>If you set a property to {{jsxref("Global_Objects/undefined", "undefined")}} but do not delete it, the <code>in</code> operator returns true for that property.</p>

<pre class="brush:js notranslate">let mycar = {make: 'Honda', model: 'Accord', year: 1998}
mycar.make = undefined
'make' in mycar   // returns true
</pre>

<pre class="brush:js notranslate">let trees = new Array('redwood', 'bay', 'cedar', 'oak', 'maple')
trees[3] = undefined
3 in trees  // returns true
</pre>

<p>The <code>in</code> operator will return <code>false</code> for empty array slots. Even if accessing it directly returns <code>undefined</code>.</p>

<pre class="brush:js notranslate">let empties = new Array(3)
empties[2] // returns undefined
2 in empties  // returns false
</pre>

<p>To avoid this, make sure a new array is always filled with non-empty values or not write to indexes past the end of array.</p>

<pre class="brush:js notranslate">let empties = new Array(3).fill(undefined)
2 in empties  // returns true
</pre>

<h3 id="Inherited_properties">Inherited properties</h3>

<p>The <code>in</code> operator returns <code>true</code> for properties in the prototype chain. (If you want to check for only <em>non-inherited</em> properties, use {{jsxref("Object.prototype.hasOwnProperty()")}} instead.)</p>

<pre class="brush:js notranslate">'toString' in {}  // returns true
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
  </tr>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-relational-operators', 'Relational Operators')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.operators.in")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/for...in">for...in</a></code></li>
 <li><code><a href="/en-US/docs/Web/JavaScript/Reference/Operators/delete">delete</a></code></li>
 <li>{{jsxref("Object.prototype.hasOwnProperty()")}}</li>
 <li>{{jsxref("Reflect.has()")}}</li>
 <li><a href="/en-US/docs/Enumerability_and_ownership_of_properties">Enumerability and ownership of properties</a></li>
</ul>
